Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushExpressions.cs	(revision 14602)
@@ -3,30 +3,10 @@
   using HeuristicLab.Algorithms.PushGP.Stack;
 
-  public abstract class PushExpression<T> : StatefullExpression<T> {
+  public abstract class PushExpression<T> : WrapperExpression<T> {
 
     protected PushExpression(T state) : base(state) { }
 
-    protected override int InitId() {
-      var hash = 19;
-
-      hash = hash * 31 + this.GetType().GetHashCode();
-      hash = hash * 31 + this.State.GetHashCode();
-
-      return hash;
-    }
-
     protected void Eval(IStack<T> stack) {
       stack.Push(this.State);
-    }
-
-    public override bool Equals(object obj) {
-      if (!(obj is PushExpression<T>)) return false;
-      var other = (PushExpression<T>)obj;
-
-      return this.State.Equals(other.State);
-    }
-
-    public override int GetHashCode() {
-      return base.GetHashCode();
     }
   }
@@ -35,8 +15,4 @@
     public IntegerPushExpression(long state)
       : base(state) {
-    }
-
-    protected override string InitStringRepresentation() {
-      return "IntegerPush";
     }
 
@@ -51,8 +27,4 @@
     }
 
-    protected override string InitStringRepresentation() {
-      return "FloatPush";
-    }
-
     public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(interpreter.FloatStack);
@@ -63,8 +35,4 @@
     public BooleanPushExpression(bool state)
       : base(state) {
-    }
-
-    protected override string InitStringRepresentation() {
-      return "BooleanPush";
     }
 
@@ -79,8 +47,4 @@
     }
 
-    protected override string InitStringRepresentation() {
-      return "NamePush";
-    }
-
     public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(interpreter.NameStack);
@@ -93,8 +57,4 @@
     }
 
-    protected override string InitStringRepresentation() {
-      return "ExecPush";
-    }
-
     public override void Eval(IPushGpInterpreter interpreter) {
       this.Eval(interpreter.ExecStack);
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/PushResultExpression.cs	(revision 14602)
@@ -5,4 +5,6 @@
 
   public abstract class PushResultExpression<T> : StatelessExpression {
+    protected PushResultExpression(string stringRepresentation) : base(stringRepresentation) { }
+
     protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc) {
       if (stack.Count < count) return;
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RandExpressions.cs	(revision 14602)
@@ -1,103 +1,98 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Generators;
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
+    using HeuristicLab.Algorithms.PushGP.Generators;
+    using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-  /// <summary>
-  ///     Pushes a random NAME.
-  /// </summary>
-  public class NameRandExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
+    /// <summary>
+    ///     Pushes a random NAME.
+    /// </summary>
+    public class NameRandExpression : StatelessExpression
     {
-      return "NAME.RAND";
+        public NameRandExpression() : base("NAME.RAND")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            var name = NameGenerator.RandomName();
+
+            interpreter.NameStack.Push(name);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes a random integer.
+    /// </summary>
+    public class IntegerRandExpression : StatelessExpression
     {
-      var name = NameGenerator.RandomName();
+        public IntegerRandExpression() : base("INTEGER.RAND")
+        {
+        }
 
-      interpreter.NameStack.Push(name);
-    }
-  }
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            var value = IntegerGenerator.RandomInteger(
+                interpreter.Configuration.MinRandomInteger,
+                interpreter.Configuration.MaxRandomInteger);
 
-  /// <summary>
-  ///     Pushes a random integer.
-  /// </summary>
-  public class IntegerRandExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.RAND";
+            interpreter.IntegerStack.Push(value);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes a random float.
+    /// </summary>
+    public class FloatRandExpression : StatelessExpression
     {
-      var value = IntegerGenerator.RandomInteger(
-        interpreter.Configuration.MinRandomInteger,
-        interpreter.Configuration.MaxRandomInteger);
+        public FloatRandExpression() : base("FLOAT.RAND")
+        {
+        }
 
-      interpreter.IntegerStack.Push(value);
-    }
-  }
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            var value = FloatGenerator.RandomFloat(
+                interpreter.Configuration.MinRandomFloat,
+                interpreter.Configuration.MaxRandomFloat);
 
-  /// <summary>
-  ///     Pushes a random float.
-  /// </summary>
-  public class FloatRandExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.RAND";
+            interpreter.FloatStack.Push(value);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes a random boolean.
+    /// </summary>
+    public class BooleanRandExpression : StatelessExpression
     {
-      var value = FloatGenerator.RandomFloat(
-        interpreter.Configuration.MinRandomFloat,
-        interpreter.Configuration.MaxRandomFloat);
+        public BooleanRandExpression() : base("BOOLEAN.RAND")
+        {
+        }
 
-      interpreter.FloatStack.Push(value);
-    }
-  }
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            var value = BooleanGenerator.RandomBoolean();
 
-  /// <summary>
-  ///     Pushes a random boolean.
-  /// </summary>
-  public class BooleanRandExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.RAND";
+            interpreter.BooleanStack.Push(value);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    /// <summary>
+    ///     Pushes random expressions onto the code stack.
+    /// </summary>
+    public class CodeRandExpression : StatelessExpression
     {
-      var value = BooleanGenerator.RandomBoolean();
+        public CodeRandExpression() : base("CODE.RAND")
+        {
+        }
 
-      interpreter.BooleanStack.Push(value);
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            if (interpreter.IntegerStack.Count == 0 ||
+                interpreter.IntegerStack.Top < 1) return;
+
+            var size = (int) (interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
+            var program = CodeGenerator.RandomProgram(size, interpreter.CustomExpressions);
+
+            interpreter.CodeStack.Push(program);
+        }
     }
-  }
-
-  /// <summary>
-  ///     Pushes random expressions onto the code stack.
-  /// </summary>
-  public class CodeRandExpression : StatelessExpression
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.RAND";
-    }
-
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      if ((interpreter.IntegerStack.Count == 0) || (interpreter.IntegerStack.Top < 1)) return;
-
-      var size = (int)(interpreter.IntegerStack.Pop() % interpreter.Configuration.MaxPointsInRandomExpression);
-
-      var expression = CodeGenerator.RandomProgram(size, interpreter.CustomExpressions);
-
-      interpreter.CodeStack.Push(expression);
-    }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/RotateExpressions.cs	(revision 14602)
@@ -1,93 +1,77 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using Interpreter;
+    using Stack;
 
-  public abstract class RotateExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack)
+    public abstract class RotateExpression<T> : StatelessExpression
     {
-      if (stack.Count < 3) return;
+        protected RotateExpression(string stringRepresentation) : base(stringRepresentation) { }
 
-      stack.Swap(3);
-    }
-  }
+        public void Eval(IStack<T> stack)
+        {
+            if (stack.Count < 3) return;
 
-  public class IntegerRotateExpression : RotateExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.ROT";
+            stack.Swap(3);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class IntegerRotateExpression : RotateExpression<long>
     {
-      this.Eval(interpreter.IntegerStack);
-    }
-  }
+        public IntegerRotateExpression() : base("INTEGER.ROT") { }
 
-  public class FloatRotateExpression : RotateExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.ROT";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatRotateExpression : RotateExpression<double>
     {
-      this.Eval(interpreter.FloatStack);
-    }
-  }
+        public FloatRotateExpression() : base("FLOAT.ROT") { }
 
-  public class BooleanRotateExpression : RotateExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.ROT";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanRotateExpression : RotateExpression<bool>
     {
-      this.Eval(interpreter.BooleanStack);
-    }
-  }
+        public BooleanRotateExpression() : base("BOOLEAN.ROT") { }
 
-  public class NameRotateExpression : RotateExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.ROT";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.BooleanStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameRotateExpression : RotateExpression<string>
     {
-      this.Eval(interpreter.NameStack);
-    }
-  }
+        public NameRotateExpression() : base("NAME.ROT") { }
 
-  public class ExecRotateExpression : RotateExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.ROT";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.NameStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecRotateExpression : RotateExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack);
-    }
-  }
+        public ExecRotateExpression() : base("EXEC.ROT") { }
 
-  public class CodeRotateExpression : RotateExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.ROT";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.ExecStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeRotateExpression : RotateExpression<Expression>
     {
-      this.Eval(interpreter.CodeStack);
+        public CodeRotateExpression() : base("CODE.ROT") { }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.CodeStack);
+        }
     }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/ShoveExpressions.cs	(revision 14602)
@@ -1,98 +1,88 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
 {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+    using Interpreter;
+    using Stack;
 
-  public abstract class ShoveExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
+    public abstract class ShoveExpression<T> : StatelessExpression
     {
-      if (integerStack.Count == 0) return;
+        protected ShoveExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-      if ((integerStack.Top > stack.Count - count) || (integerStack.Top < 0) || (stack.Count < 2)) return;
+        protected void Eval(IStack<T> stack, IStack<long> integerStack, int count = 1)
+        {
+            if (integerStack.Count == 0 ||
+                integerStack.Top > stack.Count - count ||
+                integerStack.Top < 0 ||
+                stack.Count < 2)
+                return;
 
-      var index = (int)integerStack.Pop();
-      var item = stack.Pop();
+            var index = (int) integerStack.Pop();
+            var item = stack.Pop();
 
-      stack.Insert(index, item);
-    }
-  }
-
-  public class IntegerShoveExpression : ShoveExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.SHOVE";
+            stack.Insert(index, item);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class IntegerShoveExpression : ShoveExpression<long>
     {
-      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
-    }
-  }
+        public IntegerShoveExpression() : base("INTEGER.SHOVE") { }
 
-  public class FloatShoveExpression : ShoveExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.SHOVE";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.IntegerStack, interpreter.IntegerStack, 2);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class FloatShoveExpression : ShoveExpression<double>
     {
-      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
-    }
-  }
+        public FloatShoveExpression() : base("FLOAT.SHOVE") { }
 
-  public class BooleanShoveExpression : ShoveExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.SHOVE";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class BooleanShoveExpression : ShoveExpression<bool>
     {
-      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-    }
-  }
+        public BooleanShoveExpression() : base("BOOLEAN.SHOVE") { }
 
-  public class NameShoveExpression : ShoveExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.SHOVE";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class NameShoveExpression : ShoveExpression<string>
     {
-      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
-    }
-  }
+        public NameShoveExpression() : base("NAME.SHOVE") { }
 
-  public class ExecShoveExpression : ShoveExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.SHOVE";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.NameStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class ExecShoveExpression : ShoveExpression<Expression>
     {
-      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
-    }
-  }
+        public ExecShoveExpression() : base("EXEC.SHOVE") { }
 
-  public class CodeShoveExpression : ShoveExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.SHOVE";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.ExecStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
+    public class CodeShoveExpression : ShoveExpression<Expression>
     {
-      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+        public CodeShoveExpression() : base("CODE.SHOVE")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.CodeStack, interpreter.IntegerStack);
+        }
     }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StackdepthExpressions.cs	(revision 14602)
@@ -1,78 +1,97 @@
-﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
+{
+    using Interpreter;
+    using Stack;
 
-  /// <summary>
-  ///     Pushes the stack depth onto the INTEGER stack (thereby increasing it!).
-  /// </summary>
-  /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class StackdepthExpression<T> : StatelessExpression {
-    public void Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false) {
-      var count = stack.Count;
+    /// <summary>
+    ///     Pushes the stack depth onto the INTEGER stack (thereby increasing it!).
+    /// </summary>
+    /// <typeparam name="T">Stacktype</typeparam>
+    public abstract class StackdepthExpression<T> : StatelessExpression
+    {
+        protected StackdepthExpression(string stringRepresentation) : base(stringRepresentation)
+        {
+        }
 
-      if (incremental) count += 1;
+        public void Eval(IStack<T> stack, IStack<long> integerStack, bool incremental = false)
+        {
+            var count = stack.Count;
 
-      integerStack.Push(count);
-    }
-  }
+            if (incremental) count += 1;
 
-  public class IntegerStackdepthExpression : StackdepthExpression<long> {
-    protected override string InitStringRepresentation() {
-      return "INTEGER.STACKDEPTH";
+            integerStack.Push(count);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
-    }
-  }
+    public class IntegerStackdepthExpression : StackdepthExpression<long>
+    {
+        public IntegerStackdepthExpression() : base("INTEGER.STACKDEPTH")
+        {
+        }
 
-  public class FloatStackdepthExpression : StackdepthExpression<double> {
-    protected override string InitStringRepresentation() {
-      return "FLOAT.STACKDEPTH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.IntegerStack, interpreter.IntegerStack, true);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack, interpreter.IntegerStack);
-    }
-  }
+    public class FloatStackdepthExpression : StackdepthExpression<double>
+    {
+        public FloatStackdepthExpression() : base("FLOAT.STACKDEPTH")
+        {
+        }
 
-  public class BooleanStackdepthExpression : StackdepthExpression<bool> {
-    protected override string InitStringRepresentation() {
-      return "BOOLEAN.STACKDEPTH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.FloatStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack, interpreter.IntegerStack);
-    }
-  }
+    public class BooleanStackdepthExpression : StackdepthExpression<bool>
+    {
+        public BooleanStackdepthExpression() : base("BOOLEAN.STACKDEPTH")
+        {
+        }
 
-  public class NameStackdepthExpression : StackdepthExpression<string> {
-    protected override string InitStringRepresentation() {
-      return "NAME.STACKDEPTH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.BooleanStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
-      this.Eval(interpreter.NameStack, interpreter.IntegerStack);
-    }
-  }
+    public class NameStackdepthExpression : StackdepthExpression<string>
+    {
+        public NameStackdepthExpression() : base("NAME.STACKDEPTH")
+        {
+        }
 
-  public class ExecStackdepthExpression : StackdepthExpression<Expression> {
-    protected override string InitStringRepresentation() {
-      return "EXEC.STACKDEPTH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.NameStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack, interpreter.IntegerStack);
-    }
-  }
+    public class ExecStackdepthExpression : StackdepthExpression<Expression>
+    {
+        public ExecStackdepthExpression() : base("EXEC.STACKDEPTH")
+        {
+        }
 
-  public class CodeStackdepthExpression : StackdepthExpression<Expression> {
-    protected override string InitStringRepresentation() {
-      return "CODE.STACKDEPTH";
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.ExecStack, interpreter.IntegerStack);
+        }
     }
 
-    public override void Eval(IPushGpInterpreter interpreter) {
-      this.Eval(interpreter.CodeStack, interpreter.IntegerStack);
+    public class CodeStackdepthExpression : StackdepthExpression<Expression>
+    {
+        public CodeStackdepthExpression() : base("CODE.STACKDEPTH")
+        {
+        }
+
+        public override void Eval(IPushGpInterpreter interpreter)
+        {
+            Eval(interpreter.CodeStack, interpreter.IntegerStack);
+        }
     }
-  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatefullExpression.cs	(revision 14602)
@@ -1,12 +1,27 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using System;
+  using System.Threading;
+
   public abstract class StatefullExpression<T> : Expression {
+
     protected T State { get; set; }
 
-    protected StatefullExpression(T state) {
+    private readonly Lazy<int> hashCode;
+
+    protected StatefullExpression(T state, string stringRepresentation) : base(stringRepresentation) {
       this.State = state;
+      this.hashCode = new Lazy<int>(this.CalcHashCode, LazyThreadSafetyMode.ExecutionAndPublication);
     }
 
-    public override string ToString() {
-      return this.State.ToString();
+    protected virtual int CalcHashCode() {
+      return this.State.GetHashCode();
+    }
+
+    public override bool Equals(object obj) {
+      return obj != null && (this == obj || (this.GetType() == obj.GetType() && this.GetHashCode() == obj.GetHashCode()));
+    }
+
+    public override int GetHashCode() {
+      return hashCode.Value;
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/StatelessExpression.cs	(revision 14602)
@@ -1,10 +1,8 @@
 ﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
   public abstract class StatelessExpression : Expression {
-    protected override int InitId() {
+    protected StatelessExpression(string stringRepresentation) : base(stringRepresentation) { }
+
+    public override int GetHashCode() {
       return this.GetType().GetHashCode();
-    }
-
-    public override string ToString() {
-      return this.StringRepresentation;
     }
   }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/SwapExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/SwapExpressions.cs	(revision 14601)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/SwapExpressions.cs	(revision 14602)
@@ -1,6 +1,5 @@
-﻿namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-  using HeuristicLab.Algorithms.PushGP.Interpreter;
-  using HeuristicLab.Algorithms.PushGP.Stack;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using Interpreter;
+  using Stack;
 
   /// <summary>
@@ -8,9 +7,11 @@
   /// </summary>
   /// <typeparam name="T">Stacktype</typeparam>
-  public abstract class SwapExpression<T> : StatelessExpression
-  {
-    public void Eval(IStack<T> stack)
-    {
-      if (stack.Count < 2) return;
+  public abstract class SwapExpression<T> : StatelessExpression {
+    protected SwapExpression(string stringRepresentation) : base(stringRepresentation) {
+    }
+
+    public void Eval(IStack<T> stack) {
+      if (stack.Count < 2)
+        return;
 
       stack.Swap(2);
@@ -18,79 +19,55 @@
   }
 
-  public class IntegerSwapExpression : SwapExpression<long>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "INTEGER.SWAP";
+  public class IntegerSwapExpression : SwapExpression<long> {
+    public IntegerSwapExpression() : base("INTEGER.SWAP") {
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.IntegerStack);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Eval(interpreter.IntegerStack);
     }
   }
 
-  public class FloatSwapExpression : SwapExpression<double>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "FLOAT.SWAP";
+  public class FloatSwapExpression : SwapExpression<double> {
+    public FloatSwapExpression() : base("FLOAT.SWAP") {
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.FloatStack);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Eval(interpreter.FloatStack);
     }
   }
 
-  public class BooleanSwapExpression : SwapExpression<bool>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "BOOLEAN.SWAP";
+  public class BooleanSwapExpression : SwapExpression<bool> {
+    public BooleanSwapExpression() : base("BOOLEAN.SWAP") {
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.BooleanStack);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Eval(interpreter.BooleanStack);
     }
   }
 
-  public class NameSwapExpression : SwapExpression<string>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "NAME.SWAP";
+  public class NameSwapExpression : SwapExpression<string> {
+    public NameSwapExpression() : base("NAME.SWAP") {
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.NameStack);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Eval(interpreter.NameStack);
     }
   }
 
-  public class ExecSwapExpression : SwapExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "EXEC.SWAP";
+  public class ExecSwapExpression : SwapExpression<Expression> {
+    public ExecSwapExpression() : base("EXEC.SWAP") {
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.ExecStack);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Eval(interpreter.ExecStack);
     }
   }
 
-  public class CodeSwapExpression : SwapExpression<Expression>
-  {
-    protected override string InitStringRepresentation()
-    {
-      return "CODE.SWAP";
+  public class CodeSwapExpression : SwapExpression<Expression> {
+    public CodeSwapExpression() : base("CODE.SWAP") {
     }
 
-    public override void Eval(IPushGpInterpreter interpreter)
-    {
-      this.Eval(interpreter.CodeStack);
+    public override void Eval(IPushGpInterpreter interpreter) {
+      Eval(interpreter.CodeStack);
     }
   }
